searchNodes=[{"doc":"","ref":"Rail.html","title":"Rail","type":"module"},{"doc":"","ref":"Rail.html#def/2","title":"Rail.def/2","type":"macro"},{"doc":"","ref":"Rail.html#defp/2","title":"Rail.defp/2","type":"macro"},{"doc":"","ref":"Rail.html#rail/1","title":"Rail.rail/1","type":"macro"},{"doc":"","ref":"Rail.html#rail/2","title":"Rail.rail/2","type":"macro"},{"doc":"","ref":"Rail.html#railp/2","title":"Rail.railp/2","type":"macro"},{"doc":"","ref":"Rail.Either.html","title":"Rail.Either","type":"module"},{"doc":"Alias to chain/2 . Examples iex&gt; 1 &gt;&gt;&gt; fn v -&gt; v + 10 end 11 iex&gt; { :ok , 1 } &gt;&gt;&gt; fn v -&gt; v + 10 end 11 iex&gt; :error &gt;&gt;&gt; fn v -&gt; v + 10 end { :error , nil } iex&gt; { :error , :noent } &gt;&gt;&gt; fn v -&gt; v + 10 end { :error , :noent }","ref":"Rail.Either.html#%3E%3E%3E/2","title":"Rail.Either.>>>/2","type":"function"},{"doc":"Apply a function to the either when it is ok compatible value. Examples iex&gt; 1 |&gt; Either . chain ( fn v -&gt; v + 10 end ) 11 iex&gt; { :ok , 1 } |&gt; Either . chain ( fn v -&gt; v + 10 end ) 11 iex&gt; :error |&gt; Either . chain ( fn v -&gt; v + 10 end ) { :error , nil } iex&gt; { :error , :noent } |&gt; Either . chain ( fn v -&gt; v + 10 end ) { :error , :noent }","ref":"Rail.Either.html#chain/2","title":"Rail.Either.chain/2","type":"function"},{"doc":"Create a either from a boolean. Examples iex&gt; Either . confirm ( true ) { :ok , nil } iex&gt; Either . confirm ( false , :value_error ) { :error , :value_error }","ref":"Rail.Either.html#confirm/2","title":"Rail.Either.confirm/2","type":"function"},{"doc":"Wrap a value with an error tuple. Examples iex&gt; Either . error ( 1 ) { :error , 1 } iex&gt; Either . error ( { :ok , 1 } ) { :error , { :ok , 1 } }","ref":"Rail.Either.html#error/1","title":"Rail.Either.error/1","type":"function"},{"doc":"Map a function to the either. If the either is ok , the function is applied to the value. If the either is error , it returns as is. Examples iex&gt; { :ok , 1 } |&gt; Either . map ( fn x -&gt; x + 1 end ) { :ok , 2 } iex&gt; { :error , 1 } |&gt; Either . map ( fn x -&gt; x + 1 end ) { :error , 1 } iex&gt; :ok |&gt; Either . map ( fn _ -&gt; 1 end ) { :ok , 1 }","ref":"Rail.Either.html#map/2","title":"Rail.Either.map/2","type":"function"},{"doc":"Map a function to the error tuple. Examples iex&gt; { :error , 1 } |&gt; Either . map_err ( fn x -&gt; x + 1 end ) { :error , 2 } iex&gt; { :ok , 1 } |&gt; Either . map_err ( fn x -&gt; x + 1 end ) { :ok , 1 } iex&gt; :error |&gt; Either . map_err ( fn _ -&gt; 1 end ) { :error , 1 }","ref":"Rail.Either.html#map_err/2","title":"Rail.Either.map_err/2","type":"function"},{"doc":"Convert a value into ok or error tuple. The result is a tuple having an :ok or :error atom for the first element, and a value for the second element. Examples iex&gt; Either . new ( :ok ) { :ok , nil } iex&gt; Either . new ( :error ) { :error , nil } iex&gt; Either . new ( { :ok , 3 } ) { :ok , 3 } iex&gt; Either . new ( { :error , &quot;error!&quot; } ) { :error , &quot;error!&quot; } iex&gt; Either . new ( { :ok , 1 , 2 } ) { :ok , { 1 , 2 } } iex&gt; Either . new ( { :error , &quot;error&quot; , :invalid } ) { :error , { &quot;error&quot; , :invalid } } iex&gt; Either . new ( { 1 , 2 } ) { :ok , { 1 , 2 } } iex&gt; Either . new ( { } ) { :ok , { } } iex&gt; Either . new ( 1 ) { :ok , 1 }","ref":"Rail.Either.html#new/1","title":"Rail.Either.new/1","type":"function"},{"doc":"Wrap a value with an ok tuple. Examples iex&gt; Either . ok ( 1 ) { :ok , 1 } iex&gt; Either . ok ( { :error , 1 } ) { :ok , { :error , 1 } }","ref":"Rail.Either.html#ok/1","title":"Rail.Either.ok/1","type":"function"},{"doc":"Check if the value is an ok tuple. Examples iex&gt; Either . ok? ( { :ok , 1 } ) true iex&gt; Either . ok? ( :ok ) true iex&gt; Either . ok? ( { :error , 1 } ) false iex&gt; Either . ok? ( :error ) false","ref":"Rail.Either.html#ok?/1","title":"Rail.Either.ok?/1","type":"function"},{"doc":"Transform a list of eithers to an either of a list. If any of the eithers is error , the result is error . Examples iex&gt; [ { :ok , 1 } , { :ok , 2 } ] |&gt; Either . traverse ( ) { :ok , [ 1 , 2 ] } iex&gt; [ { :ok , 1 } , { :error , &quot;error!&quot; } , { :ok , 2 } ] ...&gt; |&gt; Either . traverse ( ) { :error , &quot;error!&quot; }","ref":"Rail.Either.html#traverse/1","title":"Rail.Either.traverse/1","type":"function"},{"doc":"Unwrap a value from an ok tuple. Examples iex&gt; Either . unwrap ( { :ok , 1 } ) 1 iex&gt; Either . unwrap ( { :error , 1 } ) ** (RuntimeError) 1 iex&gt; Either . unwrap ( { :ok , 1 , 2 , 3 } ) { 1 , 2 , 3 }","ref":"Rail.Either.html#unwrap/1","title":"Rail.Either.unwrap/1","type":"function"},{"doc":"Unwrap a value from an ok tuple. If the value is an error tuple, use passed default value or function. Examples iex&gt; Either . unwrap_or ( { :ok , 1 } , 0 ) 1 iex&gt; Either . unwrap_or ( { :error , &quot;&quot; } , 0 ) 0 iex&gt; Either . unwrap_or ( { :error , &quot;&quot; } , fn -&gt; &quot;default&quot; end ) &quot;default&quot; iex&gt; Either . unwrap_or ( :error , &quot;hello&quot; ) &quot;hello&quot;","ref":"Rail.Either.html#unwrap_or/2","title":"Rail.Either.unwrap_or/2","type":"function"},{"doc":"","ref":"Rail.Either.html#t:either/1","title":"Rail.Either.either/1","type":"type"},{"doc":"","ref":"Rail.Either.html#t:either_like/0","title":"Rail.Either.either_like/0","type":"type"},{"doc":"","ref":"Rail.Either.html#t:error/1","title":"Rail.Either.error/1","type":"type"},{"doc":"","ref":"Rail.Either.html#t:error_like/0","title":"Rail.Either.error_like/0","type":"type"},{"doc":"","ref":"Rail.Either.html#t:ok/1","title":"Rail.Either.ok/1","type":"type"},{"doc":"","ref":"Rail.Either.html#t:ok_like/0","title":"Rail.Either.ok_like/0","type":"type"},{"doc":"Rail is a helper macros for &quot;Railway oriented programming&quot;. It helps you handle error cases at almost no cost with rail macro. If you are not comfortable with &quot;Railway oriented programming&quot;, see Railway oriented programming This library is mostly copied from SeokminHong/reather-lite and removed reader monad related stuffs to lower learning curve.","ref":"readme.html","title":"Rail","type":"extras"},{"doc":"def deps do [ { :rail , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"Rail - Installation","type":"extras"},{"doc":"Basic usage use Rail introduces new syntax left &lt;- right , which bind value to left when right is {:ok, value} or value or skips entire code block when right is {:error, err} or :error . defmodule Target do use Rail def div ( num , denom ) do denom &lt;- check_denom ( denom ) num / denom end def check_denom ( 0 ) do { :error , :div_by_zero } end def check_denom ( n ) do # same with {:ok, n} n end end iex&gt; Calc . div ( 10 , 2 ) 5.0 iex&gt; Calc . div ( 10 , 0 ) { :error , :div_by_zero } rail/1 is available inside other code blocks. iex&gt; rail do ... x &lt;- { :ok , 1 } ... y &lt;- { :ok , 2 } ... ... x + y ... end 3 Either.new Convert a value into ok or error tuple. The result is a tuple having an :ok or :error atom for the first element, and a value for the second element. Either.error Make an error tuple from a value. Either.map map a function to an either tuple. The given function will be applied lazily when the either is an ok tuple. Either.traverse Transform a list of eithers to an either of a list. If any of the eithers is error , the result is error . iex&gt; [ { :ok , 1 } , { :ok , 2 } ] |&gt; Either . traverse ( ) { :ok , [ 1 , 2 ] } iex&gt; [ { :ok , 1 } , { :error , &quot;error!&quot; } , { :ok , 2 } ] ...&gt; |&gt; Either . traverse ( ) { :error , &quot;error!&quot; }","ref":"readme.html#usage","title":"Rail - Usage","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"Rail - LICENSE","type":"extras"},{"doc":"MIT License Copyright (c) 2022 Jechol Lee Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]